//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.tasktrees.treeimpl;

import de.ugoe.cs.autoquest.tasktrees.treeifc.ISelection;
import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskVisitor;

/**
 * TODO comment
 * 
 * @version $Revision: $ $Date: 19.02.2012$
 * @author 2012, last modified by $Author: patrick$
 */
class Selection extends StructuringTemporalRelationship implements ISelection {

    /**  */
    private static final long serialVersionUID = 1L;

    /**
     * TODO: comment
     * 
     * @param name
     */
    Selection() {
        super("selection");
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#clone()
     */
    @Override
    public Selection clone() {
        return (Selection) super.clone();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param i
     * @param newChild
     */
    public void addChild(ITask newChild) {
        super.addChild(newChild);
        super.setDescription("selection of " + newChild);
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param i
     * @param newChild
     */
    public void addChild(int index, ITask newChild) {
        super.addChild(index, newChild);
        super.setDescription("selection of " + newChild);
    }

    /* (non-Javadoc)
     * @see de.ugoe.cs.autoquest.tasktrees.treeifc.ITemporalRelationship#accept(de.ugoe.cs.autoquest.tasktrees.treeifc.TaskVisitor)
     */
    @Override
    public void accept(ITaskVisitor visitor) {
        visitor.visit(this);
    }

}
